## gitano 0.1

=== Makefile ===
all: local

# Configuration (override on the commandline)

LUA_VER := 5.1
LUA := /usr/bin/lua$(LUA_VER)
PREFIX ?= /usr/local
INST_ROOT := $(PREFIX)
SYSCONF_DIR ?= /etc

# Internal stuff
LUA_MOD_PATH := $(INST_ROOT)/share/lua/$(LUA_VER)
LUA_MOD_INST_PATH := $(DESTDIR)$(LUA_MOD_PATH)
BIN_PATH := $(INST_ROOT)/bin
BIN_INST_PATH := $(DESTDIR)$(BIN_PATH)
LIB_BIN_PATH := $(INST_ROOT)/lib/gitano/bin
LIB_BIN_INST_PATH := $(DESTDIR)$(LIB_BIN_PATH)
SHARE_PATH := $(INST_ROOT)/share/gitano
SHARE_INST_PATH := $(DESTDIR)$(SHARE_PATH)
SKEL_INST_PATH := $(SHARE_INST_PATH)/skel
LANG_INST_PATH := $(SHARE_INST_PATH)/lang
MAN_PATH := $(INST_ROOT)/share/man
MAN_INST_PATH := $(DESTDIR)$(MAN_PATH)
PLUGIN_PATH := $(SYSCONF_DIR)/gitano/plugins:$(INST_ROOT)/lib/gitano/plugins

LIB_BINS := gitano-auth gitano-post-receive-hook gitano-update-hook	\
	    gitano-update-ssh gitano-pre-receive-hook gitano-smart-http.cgi \
	    gitano-command.cgi

BINS := gitano-setup

TEST_BIN_NAMES := gitano-test-tool

TESTS := 01-basics 02-commands-as 02-commands-config 02-commands-copy		\
         02-commands-count-objects 02-commands-create 02-commands-destroy	\
         02-commands-fsck 02-commands-gc 02-commands-graveyard			\
         02-commands-git-upload-archive 02-commands-group 02-commands-help	\
         02-commands-keyring \
         02-commands-ls 02-commands-readme 02-commands-rename 02-commands-rsync	\
         02-commands-sshkey 02-commands-user 02-commands-whoami 03-cgit-support	\
         03-shallow-push


MODS := gitano 								\
									\
	gitano.util							\
	gitano.actions gitano.config gitano.lace gitano.log		\
	gitano.markdown gitano.repository gitano.supple 		\
	gitano.command gitano.admincommand gitano.usercommand		\
	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins

SKEL_FILES := gitano-admin/rules/selfchecks.lace			\
	      gitano-admin/rules/aschecks.lace 				\
	      gitano-admin/rules/siteadmin.lace				\
	      gitano-admin/rules/destroyrepo.lace			\
	      gitano-admin/rules/remoteconfigchecks.lace		\
	      gitano-admin/rules/core.lace				\
	      gitano-admin/rules/renamerepo.lace			\
	      gitano-admin/rules/defines.lace				\
	      gitano-admin/rules/project.lace				\
	      gitano-admin/rules/adminchecks.lace			\
	      gitano-admin/rules/createrepo.lace

LANG_FILES := json.lua en.lua

MAN1S := gitano-setup.1


PLUGINS := rsync.lua archive.lua

MOD_DIRS := gitano
MOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(MODS)))
SRC_MOD_FILES := $(patsubst %,lib/%,$(MOD_FILES))

LOCAL_BINS := $(patsubst %,bin/%,$(BINS) $(LIB_BINS))
LIB_BIN_SRCS := $(patsubst %,bin/%.in,$(LIB_BINS))

TEST_BINS := $(patsubst %,testing/%,$(TEST_BIN_NAMES))
TEST_BIN_SRCS := $(patsubst %,%.in,$(TEST_BINS))

YARN := yarn

TESTS := $(patsubst %,testing/%.yarn,$(TESTS))

GEN_BIN := utils/install-lua-bin
RUN_GEN_BIN := $(LUA) $(GEN_BIN) $(LUA)
define GEN_LOCAL_BIN

$(RUN_GEN_BIN) $(shell pwd) $(shell pwd)/bin $(shell pwd)/lib $(shell pwd)/plugins $1 $2
chmod 755 $2

endef

define GEN_INSTALL_BIN

$(RUN_GEN_BIN) $(SHARE_PATH) $(LIB_BIN_PATH) $(LUA_MOD_PATH) $(PLUGIN_PATH) $1 $2
chmod 755 $2

endef

define GEN_INSTALL_MAN

cp $1 $2
chmod 644 $2

endef

define GEN_INSTALL_MOD

install -m 644 $1 $2

endef

local: $(LOCAL_BINS)

clean:
	@echo "CLEAN: local binaries"
	@$(RM) $(LOCAL_BINS)
	@echo "CLEAN: test binaries"
	@$(RM) $(TEST_BINS)

distclean: clean
	@find . -name "*~" -delete

bin/%: bin/%.in $(GEN_BIN)
	$(call GEN_LOCAL_BIN,$<,$@)

testing/%: testing/%.in $(GEN_BIN)
	$(call GEN_LOCAL_BIN,$<,$@)

install: install-bins install-lib-bins install-mods install-skel install-man install-plugins install-lang

install-man:
	mkdir -p $(MAN_INST_PATH)/man1
	$(foreach MAN,$(MAN1S),$(call GEN_INSTALL_MAN,doc/$(MAN),$(MAN_INST_PATH)/man1/$(MAN)))

install-bins: $(BIN_SRCS) $(GEN_BIN)
	mkdir -p $(BIN_INST_PATH)
	$(foreach BIN,$(BINS),$(call GEN_INSTALL_BIN,bin/$(BIN).in,$(BIN_INST_PATH)/$(BIN)))

install-lib-bins: $(LIB_BIN_SRCS) $(GEN_BIN)
	mkdir -p $(LIB_BIN_INST_PATH)
	$(foreach BIN,$(LIB_BINS),$(call GEN_INSTALL_BIN,bin/$(BIN).in,$(LIB_BIN_INST_PATH)/$(BIN)))

install-mods: $(SRC_MOD_FILES)
	mkdir -p $(patsubst %,$(LUA_MOD_INST_PATH)/%,$(MOD_DIRS))
	$(foreach MOD,$(MOD_FILES),$(call GEN_INSTALL_MOD,lib/$(MOD),$(LUA_MOD_INST_PATH)/$(MOD)))

install-skel:
	mkdir -p $(SKEL_INST_PATH)/gitano-admin/rules
	for SKELFILE in $(SKEL_FILES); do \
		install -m 644 skel/$$SKELFILE $(SKEL_INST_PATH)/$$SKELFILE; \
	done

install-lang:
	mkdir -p $(LANG_INST_PATH)
	for LANGFILE in $(LANG_FILES); do \
		install -m 644 lang/$$LANGFILE $(LANG_INST_PATH)/$$LANGFILE; \
	done

install-plugins:
	mkdir -p $(DESTDIR)$(INST_ROOT)/lib/gitano/plugins
	mkdir -p $(DESTDIR)$(SYSCONF_DIR)/gitano/plugins
	for PLUGIN in $(PLUGINS); do \
		install -m 644 plugins/$$PLUGIN $(DESTDIR)$(INST_ROOT)/lib/gitano/plugins; \
	done
	for LANGFILE in $(wildcard $(patsubst %.lua,plugins/%_*.lua,$(PLUGINS))); do \
		install -m 644 $$LANGFILE $(DESTDIR)$(INST_ROOT)/lib/gitano/plugins; \
	done

YARN_ARGS :=
ifneq ($(LUA_PATH),)
YARN_ARGS += --env LUA_PATH="$(LUA_PATH)"
endif
ifneq ($(LUA_CPATH),)
YARN_ARGS += --env LUA_CPATH="$(LUA_CPATH)"
endif
ifneq ($(SCENARIO),)
YARN_ARGS += --run "$(SCENARIO)"
endif

test: local $(TEST_BINS)
	@$(YARN) --env GTT="$$(pwd)/testing/gitano-test-tool"			\
		 $(YARN_ARGS)                                                   \
	        testing/library.yarn $(TESTS)

testing/%: testing/%.in $(GEN_BIN)
	$(call GEN_LOCAL_BIN,$<,$@)

=== debian/changelog ===
gitano (0.1-2) unstable; urgency=medium

  * Add gnupg to Build-Depends and Depends. (Closes: #841628)

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 22 Oct 2016 10:48:55 +0900

gitano (0.1-1) unstable; urgency=medium

  * Initial packaging of Gitano as a separate project.
  * Closes: #700408

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Tue, 18 Oct 2016 23:08:40 +0900

=== debian/control ===
Source: gitano
Section: interpreters
Priority: optional
Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
Build-Depends: debhelper (>= 9.20120909~), lua-luxio, cmdtest (>= 0.12),
  lua-lace, lua-supple (>=1.0.7), lua-clod, lua-gall, lua-scrypt, git, lua5.1,
  lua-rex-pcre, lua-tongue, rsync, gnupg
Standards-Version: 3.9.8
Homepage: https://www.gitano.org.uk/supple/

Package: gitano
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, git, lua-lace, lua-supple,
  lua-clod, lua-gall, lua-scrypt, lua-luxio0, lua5.1, lua-rex-pcre, rsync,
  lua-tongue, gnupg
Description: Git service manager
 Gitano is a Git service manager along similar lines to Gitosos or Gitolite.
 Gitano is focussed on being configured entirely via Git and can be commanded
 over SSH.  Gitano has support for running hooks with limited functionality in
 a sandbox so as to allow for untrusted parties writing hook code.  Gitano also
 has a fully-fledged ACL system which allows individual projects to create
 their own rulesets, along with supporting complex delegable permissions.

=== debian/rules ===
#!/usr/bin/make -f

# Set up the variables the Gitano makefile needs
PREFIX:=/usr
export PREFIX
LUA_VER:=5.1
export LUA_VER

# And Debhelper the world

%:
	dh $@

## gitano 0.2

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 LUA_VER := 5.1
 LUA := /usr/bin/lua$(LUA_VER)
+LUAC := /usr/bin/luac$(LUA_VER)
 PREFIX ?= /usr/local
 INST_ROOT := $(PREFIX)
 SYSCONF_DIR ?= /etc
@@ -47,7 +48,8 @@
 	gitano.actions gitano.config gitano.lace gitano.log		\
 	gitano.markdown gitano.repository gitano.supple 		\
 	gitano.command gitano.admincommand gitano.usercommand		\
-	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins
+	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins\
+	gitano.i18n
 
 SKEL_FILES := gitano-admin/rules/selfchecks.lace			\
 	      gitano-admin/rules/aschecks.lace 				\
@@ -112,6 +114,7 @@
 endef
 
 local: $(LOCAL_BINS)
+	$(LUAC) -p $(LOCAL_BINS)
 
 clean:
 	@echo "CLEAN: local binaries"
@@ -168,7 +171,7 @@
 		install -m 644 $$LANGFILE $(DESTDIR)$(INST_ROOT)/lib/gitano/plugins; \
 	done
 
-YARN_ARGS :=
+YARN_ARGS ?=
 ifneq ($(LUA_PATH),)
 YARN_ARGS += --env LUA_PATH="$(LUA_PATH)"
 endif
@@ -179,10 +182,40 @@
 YARN_ARGS += --run "$(SCENARIO)"
 endif
 
+ifneq ($(YARN_SNAPSHOT),)
+YARN_ARGS += --snapshot
+endif
+
+TEST_PROTO ?= ssh
+
+ifeq ($(filter $(TEST_PROTO),ssh http),)
+$(error TEST_PROTO should be ssh or http)
+endif
+
+basictest: local $(TEST_BINS)
+	@echo "Running basic yarns in '$(TEST_PROTO)' mode"
+	@echo "Set TEST_PROTO if you want to change that"
+	@$(YARN)							 \
+		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
+		--env GTT_PROTO=$(TEST_PROTO) 				 \
+		$(YARN_ARGS)                                             \
+	        testing/library.yarn testing/01*.yarn
+
 test: local $(TEST_BINS)
-	@$(YARN) --env GTT="$$(pwd)/testing/gitano-test-tool"			\
-		 $(YARN_ARGS)                                                   \
+	@echo "Running full yarns in 'ssh' mode"
+	@$(YARN)							 \
+		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
+		--env GTT_PROTO=ssh 					 \
+		$(YARN_ARGS)                                             \
+	        testing/library.yarn $(TESTS)
+	@echo "Running full yarns in 'http' mode"
+	@$(YARN)							 \
+		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
+		--env GTT_PROTO=ssh 					 \
+		$(YARN_ARGS)                                             \
 	        testing/library.yarn $(TESTS)
 
 testing/%: testing/%.in $(GEN_BIN)
 	$(call GEN_LOCAL_BIN,$<,$@)
+
+check: test

=== debian/changelog ===
gitano (0.2-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 03 Dec 2016 18:03:39 +0000

gitano (0.1-3) unstable; urgency=medium

  * Add curl to Depends since it's needed for HTTP(s) transactions from
    hook functions.

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 05 Nov 2016 11:28:52 +0000

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}, git, lua-lace, lua-supple,
   lua-clod, lua-gall, lua-scrypt, lua-luxio0, lua5.1, lua-rex-pcre, rsync,
-  lua-tongue, gnupg
+  lua-tongue, gnupg, curl
 Description: Git service manager
  Gitano is a Git service manager along similar lines to Gitosos or Gitolite.
  Gitano is focussed on being configured entirely via Git and can be commanded

## gitano 0.8.1

=== doc/admin/Makefile ===
sources = $(wildcard *.mdwn)

all: gitano-admin-doc.pdf gitano-admin-doc.html

gitano-admin-doc.pdf: $(sources) Makefile
	pandoc --toc -o gitano-admin-doc.pdf $(sources)

gitano-admin-doc.html: $(sources) Makefile
	pandoc --toc --standalone -o gitano-admin-doc.html $(sources)

=== debian/changelog ===
gitano (0.8.1-1) unstable; urgency=medium

  * New upstream release
  * Build-depend on procps so that the HTTP test suite can tear down
    cleanly

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Mon, 02 Jan 2017 19:06:29 +0000

gitano (0.8-1) unstable; urgency=medium

  * New upstream release
  * Clean up copyright statement because markdown.lua is no longer
    included in upstream
  * Add apache2-utils and lighttpd to the build-depends since the HTTP
    test suite depends on them.
  * Suggest git-annex so that the git-annex-shell plugin will work
  * Recommend rsync and apache2-utils so that the rsync plugin and the
    passwd command will work.

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Mon, 02 Jan 2017 18:26:42 +0000

=== debian/control ===
Source: gitano
Section: interpreters
Priority: optional
Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
Build-Depends: debhelper (>= 9.20120909~), lua-luxio, cmdtest (>= 0.12),
  lua-lace, lua-supple (>=1.0.7), lua-clod, lua-gall, lua-scrypt, git, lua5.1,
  lua-rex-pcre, lua-tongue, rsync, gnupg, apache2-utils, lighttpd, procps
Standards-Version: 3.9.8
Homepage: https://www.gitano.org.uk/supple/

Package: gitano
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}, git, lua-lace, lua-supple,
  lua-clod, lua-gall, lua-scrypt, lua-luxio0, lua5.1, lua-rex-pcre,
  lua-tongue, gnupg, curl
Recommends: rsync, apache2-utils
Suggests: git-annex
Description: Git service manager
 Gitano is a Git service manager along similar lines to Gitosos or Gitolite.
 Gitano is focussed on being configured entirely via Git and can be commanded
 over SSH.  Gitano has support for running hooks with limited functionality in
 a sandbox so as to allow for untrusted parties writing hook code.  Gitano also
 has a fully-fledged ACL system which allows individual projects to create
 their own rulesets, along with supporting complex delegable permissions.

## gitano 1.0

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
          02-commands-fsck 02-commands-gc 02-commands-graveyard			\
          02-commands-git-upload-archive 02-commands-group 02-commands-help	\
          02-commands-keyring \
-         02-commands-ls 02-commands-readme 02-commands-rename 02-commands-rsync	\
+         02-commands-ls 02-commands-rename 02-commands-rsync	\
          02-commands-sshkey 02-commands-user 02-commands-whoami 03-cgit-support	\
          03-shallow-push
 
@@ -46,7 +46,7 @@
 									\
 	gitano.util							\
 	gitano.actions gitano.config gitano.lace gitano.log		\
-	gitano.markdown gitano.repository gitano.supple 		\
+	gitano.repository gitano.supple 		\
 	gitano.command gitano.admincommand gitano.usercommand		\
 	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins\
 	gitano.i18n
@@ -68,7 +68,7 @@
 MAN1S := gitano-setup.1
 
 
-PLUGINS := rsync.lua archive.lua
+PLUGINS := rsync.lua archive.lua git-annex.lua
 
 MOD_DIRS := gitano
 MOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(MODS)))
@@ -171,19 +171,19 @@
 		install -m 644 $$LANGFILE $(DESTDIR)$(INST_ROOT)/lib/gitano/plugins; \
 	done
 
-YARN_ARGS ?=
+override YARN_ARGS := $(YARN_ARGS)
 ifneq ($(LUA_PATH),)
-YARN_ARGS += --env LUA_PATH="$(LUA_PATH)"
+override YARN_ARGS += --env LUA_PATH="$(LUA_PATH)"
 endif
 ifneq ($(LUA_CPATH),)
-YARN_ARGS += --env LUA_CPATH="$(LUA_CPATH)"
+override YARN_ARGS += --env LUA_CPATH="$(LUA_CPATH)"
 endif
 ifneq ($(SCENARIO),)
-YARN_ARGS += --run "$(SCENARIO)"
+override YARN_ARGS += --run "$(SCENARIO)"
 endif
 
 ifneq ($(YARN_SNAPSHOT),)
-YARN_ARGS += --snapshot
+override YARN_ARGS += --snapshot
 endif
 
 TEST_PROTO ?= ssh
@@ -192,28 +192,51 @@
 $(error TEST_PROTO should be ssh or http)
 endif
 
-basictest: local $(TEST_BINS)
+ifeq ($(HTTP_FIRST_TEST_PORT),)
+HTTP_FIRST_TEST_PORT = 8080
+endif
+
+plugin-check:
+	$(LUAC) -p $(patsubst %,plugins/%,$(PLUGINS))
+	for PLUGIN in $(patsubst %,plugins/%,$(PLUGINS)); do \
+		env LUA_PATH="$(shell pwd)/lib/?.lua;;" $(LUA) $$PLUGIN; \
+	done
+
+basictest: local plugin-check $(TEST_BINS)
 	@echo "Running basic yarns in '$(TEST_PROTO)' mode"
 	@echo "Set TEST_PROTO if you want to change that"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
 		--env GTT_PROTO=$(TEST_PROTO) 				 \
+		--env HTTP_FIRST_TEST_PORT=$(HTTP_FIRST_TEST_PORT)       \
 		$(YARN_ARGS)                                             \
 	        testing/library.yarn testing/01*.yarn
 
-test: local $(TEST_BINS)
+test: local plugin-check sshtests httptests
+
+sshtests: $(TEST_BINS)
 	@echo "Running full yarns in 'ssh' mode"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
 		--env GTT_PROTO=ssh 					 \
+		--env HTTP_FIRST_TEST_PORT=$(HTTP_FIRST_TEST_PORT)       \
 		$(YARN_ARGS)                                             \
 	        testing/library.yarn $(TESTS)
+
+ifeq ($(SKIP_HTTP_TESTS),)
+httptests: $(TEST_BINS)
 	@echo "Running full yarns in 'http' mode"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
-		--env GTT_PROTO=ssh 					 \
+		--env GTT_PROTO=http 					 \
+		--env HTTP_FIRST_TEST_PORT=$(HTTP_FIRST_TEST_PORT)       \
 		$(YARN_ARGS)                                             \
 	        testing/library.yarn $(TESTS)
+else
+httptests:
+	@echo "WARNING: Running of yarns in 'http' mode disabled."
+	@echo "WARNING: Cannot guarantee Gitano will work in HTTP mode."
+endif
 
 testing/%: testing/%.in $(GEN_BIN)
 	$(call GEN_LOCAL_BIN,$<,$@)

=== doc/admin/Makefile ===
sources = $(wildcard *.mdwn)

all: gitano-admin-doc.pdf gitano-admin-doc.html

gitano-admin-doc.pdf: $(sources) Makefile titling.tex header.tex
	pandoc --standalone --toc --chapters -V documentclass:report -V geometry:margin=1in -V graphics:true -V papersize:a4paper -H titling.tex -H header.tex -o gitano-admin-doc.pdf $(sources)

gitano-admin-doc.html: $(sources) Makefile manual.css image.html
	pandoc --toc --standalone --css manual.css -B image.html -o gitano-admin-doc.html $(sources)

clean:
	$(RM) gitano-admin-doc.pdf gitano-admin-doc.html

=== debian/changelog ===
gitano (1.0-2) unstable; urgency=medium

  * Fix missing copyright field

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Wed, 18 Jan 2017 23:21:46 +0000

gitano (1.0-1) unstable; urgency=medium

  * New upstream release
  * Includes administrator manual
      * Significant updates to debian/copyright
      * Addition of pandoc et al. to the build dependencies

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sun, 15 Jan 2017 16:19:33 +0000

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,11 @@
 Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
 Build-Depends: debhelper (>= 9.20120909~), lua-luxio, cmdtest (>= 0.12),
   lua-lace, lua-supple (>=1.0.7), lua-clod, lua-gall, lua-scrypt, git, lua5.1,
-  lua-rex-pcre, lua-tongue, rsync, gnupg, apache2-utils, lighttpd, procps
+  lua-rex-pcre, lua-tongue, rsync, gnupg, apache2-utils, lighttpd, procps,
+  pandoc, texlive-latex-recommended, texlive-xetex, texlive-luatex, lmodern,
+  texlive-fonts-recommended
 Standards-Version: 3.9.8
-Homepage: https://www.gitano.org.uk/supple/
+Homepage: https://www.gitano.org.uk/
 
 Package: gitano
 Architecture: all

## gitano 1.1

=== Makefile ===
--- 
+++ 
@@ -32,14 +32,15 @@
 
 TEST_BIN_NAMES := gitano-test-tool
 
-TESTS := 01-basics 02-commands-as 02-commands-config 02-commands-copy		\
-         02-commands-count-objects 02-commands-create 02-commands-destroy	\
-         02-commands-fsck 02-commands-gc 02-commands-graveyard			\
-         02-commands-git-upload-archive 02-commands-group 02-commands-help	\
-         02-commands-keyring \
-         02-commands-ls 02-commands-rename 02-commands-rsync	\
-         02-commands-sshkey 02-commands-user 02-commands-whoami 03-cgit-support	\
-         03-shallow-push
+TESTS := 01-basics 01-hooks 02-commands-as 02-commands-config 02-commands-copy  \
+         02-commands-count-objects 02-commands-create 02-commands-destroy       \
+         02-commands-fsck 02-commands-gc 02-commands-graveyard                  \
+         02-commands-git-upload-archive 02-commands-group 02-commands-help      \
+         02-commands-keyring                                                    \
+         02-commands-ls 02-commands-rename 02-commands-rsync                    \
+         02-commands-sshkey 02-commands-user 02-commands-whoami 03-cgit-support \
+         03-shallow-push 03-treedelta-rules 03-force-pushing                    \
+         03-dangling-HEAD 03-config-user-whitelist
 
 
 MODS := gitano 								\
@@ -49,7 +50,7 @@
 	gitano.repository gitano.supple 		\
 	gitano.command gitano.admincommand gitano.usercommand		\
 	gitano.repocommand gitano.copycommand gitano.auth gitano.plugins\
-	gitano.i18n
+	gitano.i18n gitano.hooks gitano.patterns
 
 SKEL_FILES := gitano-admin/rules/selfchecks.lace			\
 	      gitano-admin/rules/aschecks.lace 				\
@@ -61,7 +62,8 @@
 	      gitano-admin/rules/defines.lace				\
 	      gitano-admin/rules/project.lace				\
 	      gitano-admin/rules/adminchecks.lace			\
-	      gitano-admin/rules/createrepo.lace
+	      gitano-admin/rules/createrepo.lace			\
+	      gitano-admin/rules/simpleprojectauth.lace
 
 LANG_FILES := json.lua en.lua
 
@@ -69,6 +71,18 @@
 
 
 PLUGINS := rsync.lua archive.lua git-annex.lua
+
+TEST_PLUGINS := testing-hooks.lua demo.lua
+
+UNSUPPORTED_PLUGINS := git-multimail.lua
+
+COVERAGE := no
+
+ifeq ($(COVERAGE),yes)
+
+MODS := $(MODS) gitano.coverage
+
+endif
 
 MOD_DIRS := gitano
 MOD_FILES := $(patsubst %,%.lua,$(subst .,/,$(MODS)))
@@ -86,20 +100,59 @@
 
 GEN_BIN := utils/install-lua-bin
 RUN_GEN_BIN := $(LUA) $(GEN_BIN) $(LUA)
+
+ifeq ($(COVERAGE),yes)
 define GEN_LOCAL_BIN
 
+$(RUN_GEN_BIN) $(shell pwd) $(shell pwd)/bin $(shell pwd)/lib $(shell pwd)/plugins $1 $2 $(shell pwd)/extras/luacov/src $(shell pwd)/.coverage/
+chmod 755 $2
+
+endef
+ifeq ($(COVER_GTT),yes)
+define GEN_LOCAL_TESTING_BIN
+
+$(RUN_GEN_BIN) $(shell pwd)/testing/inst/share/gitano $(shell pwd)/testing/inst/lib/gitano/bin $(shell pwd)/testing/inst/share/lua/5.1 $(shell pwd)/testing/inst/lib/gitano/plugins $1 $2 $(shell pwd)/extras/luacov/src $(shell pwd)/.coverage/
+chmod 755 $2
+
+endef
+else
+define GEN_LOCAL_TESTING_BIN
+
+$(RUN_GEN_BIN) $(shell pwd)/testing/inst/share/gitano $(shell pwd)/testing/inst/lib/gitano/bin $(shell pwd)/testing/inst/share/lua/5.1 $(shell pwd)/testing/inst/lib/gitano/plugins $1 $2
+chmod 755 $2
+
+endef
+endif
+else
+define GEN_LOCAL_BIN
+
 $(RUN_GEN_BIN) $(shell pwd) $(shell pwd)/bin $(shell pwd)/lib $(shell pwd)/plugins $1 $2
 chmod 755 $2
 
 endef
-
+define GEN_LOCAL_TESTING_BIN
+
+$(RUN_GEN_BIN) $(shell pwd)/testing/inst/share/gitano $(shell pwd)/testing/inst/lib/gitano/bin $(shell pwd)/testing/inst/share/lua/5.1 $(shell pwd)/testing/inst/lib/gitano/plugins $1 $2
+chmod 755 $2
+
+endef
+endif
+
+ifeq ($(COVERAGE),yes)
 define GEN_INSTALL_BIN
 
+$(RUN_GEN_BIN) $(SHARE_PATH) $(LIB_BIN_PATH) $(LUA_MOD_PATH) $(PLUGIN_PATH) $1 $2 $(shell pwd)/extras/luacov/src $(shell pwd)/.coverage/
+chmod 755 $2
+
+endef
+else
+define GEN_INSTALL_BIN
+
 $(RUN_GEN_BIN) $(SHARE_PATH) $(LIB_BIN_PATH) $(LUA_MOD_PATH) $(PLUGIN_PATH) $1 $2
 chmod 755 $2
 
 endef
-
+endif
 define GEN_INSTALL_MAN
 
 cp $1 $2
@@ -113,23 +166,53 @@
 
 endef
 
-local: $(LOCAL_BINS)
-	$(LUAC) -p $(LOCAL_BINS)
-
-clean:
-	@echo "CLEAN: local binaries"
-	@$(RM) $(LOCAL_BINS)
+define GEN_LOCAL_MOD
+
+$(RUN_GEN_BIN) $(shell pwd) $(shell pwd)/bin $(shell pwd)/lib $(shell pwd)/plugins $1 $2
+
+endef
+
+LOCAL_MODS := lib/gitano/coverage.lua
+
+local: $(LOCAL_BINS) $(LOCAL_MODS)
+	@$(LUAC) -p $(LOCAL_BINS) $(LOCAL_MODS)
+	@mkdir -p .coverage
+ifeq ($(COVERAGE),yes)
+	@echo NOTE: Coverage gathering enabled
+	@if ! test -r extras/luacov/src/luacov; then \
+		echo "CANNOT COVERAGE TEST, LUACOV MODULE NOT AVAILABLE"; \
+		echo "Please run: git submodule init && git submodule update"; \
+	fi
+else
+	@echo NOTE: Coverage gathering is not enabled
+endif
+
+clean: cleanbins
+	@echo "CLEAN: coverage stats and reports"
+	@$(RM) -r .coverage luacov.stats.out luacov.report.out
+
+cleanbins:
+	@echo "CLEAN: local binaries and modules"
+	@$(RM) $(LOCAL_BINS) $(LOCAL_MODS)
 	@echo "CLEAN: test binaries"
 	@$(RM) $(TEST_BINS)
+	@echo "CLEAN: test install"
+	@$(RM) -r testing/inst
 
 distclean: clean
 	@find . -name "*~" -delete
 
-bin/%: bin/%.in $(GEN_BIN)
-	$(call GEN_LOCAL_BIN,$<,$@)
-
-testing/%: testing/%.in $(GEN_BIN)
-	$(call GEN_LOCAL_BIN,$<,$@)
+bin/%: bin/%.in $(GEN_BIN) FORCE
+	@$(call GEN_LOCAL_BIN,$<,$@)
+
+testing/%: testing/%.in $(GEN_BIN) FORCE
+	@$(call GEN_LOCAL_TESTING_BIN,$<,$@)
+
+lib/gitano/%.lua: lib/gitano/%.lua.in $(GEN_BIN) FORCE
+	@$(call GEN_LOCAL_MOD,$<,$@)
+
+FORCE:
+.PHONY: FORCE
 
 install: install-bins install-lib-bins install-mods install-skel install-man install-plugins install-lang
 
@@ -196,13 +279,22 @@
 HTTP_FIRST_TEST_PORT = 8080
 endif
 
+test-install:
+	@$(RM) -r testing/inst
+	@$(MAKE) PREFIX="$(shell pwd)/testing/inst" \
+              SYSCONF_DIR="$(shell pwd)/testing/inst/etc" \
+              install >/dev/null
+	@for P in $(TEST_PLUGINS); do \
+		cp plugins/$$P "$(shell pwd)/testing/inst/etc/gitano/plugins/"; \
+	done
+
 plugin-check:
-	$(LUAC) -p $(patsubst %,plugins/%,$(PLUGINS))
-	for PLUGIN in $(patsubst %,plugins/%,$(PLUGINS)); do \
+	$(LUAC) -p $(patsubst %,plugins/%,$(PLUGINS) $(TEST_PLUGINS) $(UNSUPPORTED_PLUGINS))
+	for PLUGIN in $(patsubst %,plugins/%,$(PLUGINS) $(TEST_PLUGINS)); do \
 		env LUA_PATH="$(shell pwd)/lib/?.lua;;" $(LUA) $$PLUGIN; \
 	done
 
-basictest: local plugin-check $(TEST_BINS)
+basictest: local plugin-check $(TEST_BINS) test-install
 	@echo "Running basic yarns in '$(TEST_PROTO)' mode"
 	@echo "Set TEST_PROTO if you want to change that"
 	@$(YARN)							 \
@@ -214,7 +306,7 @@
 
 test: local plugin-check sshtests httptests
 
-sshtests: $(TEST_BINS)
+sshtests: $(TEST_BINS) test-install
 	@echo "Running full yarns in 'ssh' mode"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
@@ -224,7 +316,7 @@
 	        testing/library.yarn $(TESTS)
 
 ifeq ($(SKIP_HTTP_TESTS),)
-httptests: $(TEST_BINS)
+httptests: $(TEST_BINS) test-install
 	@echo "Running full yarns in 'http' mode"
 	@$(YARN)							 \
 		--env GTT="$$(pwd)/testing/gitano-test-tool"		 \
@@ -238,7 +330,12 @@
 	@echo "WARNING: Cannot guarantee Gitano will work in HTTP mode."
 endif
 
-testing/%: testing/%.in $(GEN_BIN)
-	$(call GEN_LOCAL_BIN,$<,$@)
-
 check: test
+
+coverage-report:
+	@echo "COVERAGE: Merge stats..."
+	@env LUA_PATH="$(shell pwd)/extras/luacov/src/?.lua;;" $(LUA) utils/merge-luacov-stats .coverage/luacov.stats-*.out
+	@echo "COVERAGE: Generate report..."
+	@env LUA_PATH="$(shell pwd)/extras/luacov/src/?.lua;;" $(LUA) extras/luacov/src/bin/luacov
+	@echo "COVERAGE: Summary:"
+	@sed '0,/^Summary/d' < luacov.report.out | tail -n +2 | sed -e's/^/COVERAGE: /'

=== debian/changelog ===
gitano (1.1-1) unstable; urgency=medium

  * New upstream release
  * Also copy the multimail plugin and its README to usr/share/doc

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Thu, 03 Aug 2017 11:12:31 -0400

=== debian/rules ===
--- 
+++ 
@@ -10,3 +10,7 @@
 
 %:
 	dh $@
+
+override_dh_auto_build:
+	make
+	make -C doc/admin

## gitano 1.1.1

=== debian/changelog ===
gitano (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * Override PANDOC_ARGS_CHAPTERS for new pandoc

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Fri, 01 Jun 2018 11:04:49 +0100

=== debian/watch ===
version=3
https://git.gitano.org.uk/gitano.git /gitano\.git/snapshot/gitano-(.+)\.tar.bz2

## gitano 1.2

=== doc/admin/Makefile ===
sources = $(wildcard *.mdwn)

all: gitano-admin-doc.pdf gitano-admin-doc.html

PANDOC_ARGS_SHAPE := --standalone --toc
PANDOC_ARGS_CHAPTERS := --chapters
PANDOC_PDF_ARGS_SETTINGS := -V documentclass:report -V geometry:margin=1in -V graphics:true -V papersize:a4paper
PANDOC_PDF_ARGS := $(PANDOC_ARGS_SHAPE) $(PANDOC_ARGS_CHAPTERS) $(PANDOC_PDF_ARGS_SETTINGS) -H titling.tex -H header.tex

PANDOC_HTML_ARGS_SETTINGS := --css manual.css -B image.html
PANDOC_HTML_ARGS := $(PANDOC_ARGS_SHAPE) $(PANDOC_HTML_ARGS_SETTINGS)

gitano-admin-doc.pdf: $(sources) Makefile titling.tex header.tex
	pandoc $(PANDOC_PDF_ARGS) -o gitano-admin-doc.pdf $(sources)

gitano-admin-doc.html: $(sources) Makefile manual.css image.html
	pandoc $(PANDOC_HTML_ARGS) -o gitano-admin-doc.html $(sources)

clean:
	$(RM) gitano-admin-doc.pdf gitano-admin-doc.html

=== debian/changelog ===
gitano (1.2-1) unstable; urgency=medium

  * New upstream release
    Closes: #876078
  * Apply patch from Jonathan Dowland to correct debian/copyright
    Closes: #907989

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Sat, 19 Jan 2019 13:55:33 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
   lua-lace, lua-supple (>=1.0.7), lua-clod, lua-gall, lua-scrypt, git, lua5.1,
   lua-rex-pcre, lua-tongue, rsync, gnupg, apache2-utils, lighttpd, procps,
   pandoc, texlive-latex-recommended, texlive-xetex, texlive-luatex, lmodern,
-  texlive-fonts-recommended
+  texlive-fonts-recommended, wget
 Standards-Version: 3.9.8
 Homepage: https://www.gitano.org.uk/

=== debian/rules ===
--- 
+++ 
@@ -13,4 +13,4 @@
 
 override_dh_auto_build:
 	make
-	make -C doc/admin
+	make -C doc/admin PANDOC_ARGS_CHAPTERS=--top-level-division=chapter
